#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <queue>

using namespace std;

int main() {
    int nodeAmount, edgeAmount;

    cin >> nodeAmount >> edgeAmount;
    set<int> startNodes, endNodes;
    vector<set<int>> children(nodeAmount), coreChildren(nodeAmount);

    for (int i = 0; i < nodeAmount; i++) {
        startNodes.insert(i);
        endNodes.insert(i);
    }

    for (int i = 0; i < edgeAmount; i++) {
        int x, y;
        cin >> x >> y;
        children[x - 1].insert(y - 1);
        startNodes.erase(y - 1);
        endNodes.erase(x - 1);
    }

    auto startNode = *startNodes.begin();
    auto endNode = *endNodes.begin();

    queue<int> queue;
    set<int> visited;

    queue.push(startNode);
    visited.insert(startNode);

    while (!queue.empty()) {
        auto node = queue.front();
        queue.pop();

        for (auto child : children[node]) {
            if (visited.count(child) == 0) {
                queue.push(child);
                visited.insert(child);
                coreChildren[node].insert(child);
            }
        }
    }

    for (int startNode = 0; startNode < nodeAmount; startNode++) {
        visited.clear();
        vector<int> parent(nodeAmount);

        visited.insert(startNode);
        parent[startNode] = -1;
        queue.push(startNode);

        while (!queue.empty()) {
            auto node = queue.front();
            queue.pop();

            if (node == endNode) {
                while (parent[node] != -1) {
                    coreChildren[parent[node]].insert(node);
                    node = parent[node];
                }

                break;
            }

            for (auto child : children[node]) {
                if (visited.count(child) == 0) {
                    queue.push(child);
                    visited.insert(child);
                    parent[child] = node;
                }
            }
        }
    }

    int result = edgeAmount;

    for (const auto &nodes : coreChildren) {
        result -= nodes.size();
    }

    cout << result << endl;

    return 0;
}